local mod = ...



-- Asset -------------------------------------------------------------------------------------
mod:registerAssetId("models/Pagan4.fbx/Prefab/Grove1Part", "PREFAB_PAGAN_GROVE1")



-- Components -------------------------------------------------------------------------------------



-- Platform -------------------------------------------------------------------------------------
-- mod:configurePrefabFlagList("models/Pagan2.fbx/Prefab/StoneCircle1Part", { "PLATFORM" })



-- Material -------------------------------------------------------------------------------------
mod:registerAssetId("models/Pagan4.fbx/Materials/Material.Oak", "MATERIAL_PAGAN_OAK")

mod:override({
    Id = "MATERIAL_PAGAN_OAK",
    HasAlphaTest = true
})



-- Building Asset Processor -------------------------------------------------------------------------------------
mod:registerAssetProcessor("models/Pagan4.fbx", { DataType = "BUILDING_ASSET_PROCESSOR" })



-- Grounding -------------------------------------------------------------------------------------
mod:registerPrefabComponent("models/Pagan4.fbx/Prefab/Grove1Part/Idol.001", {DataType = "COMP_GROUNDED"})

for i=1, 12, 1 do
	mod:registerPrefabComponent("models/Pagan4.fbx/Prefab/Grove1Part/Tree." .. string.sub("000" .. i, -3), {DataType = "COMP_GROUNDED"})
end

for i=1, 121, 1 do
	mod:registerPrefabComponent("models/Pagan4.fbx/Prefab/Grove1Part/Pebble." .. string.sub("000" .. i, -3), {DataType = "COMP_GROUNDED"})
end



-- Building Part: Grove 1 -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_PAGAN_GROVE1",
	Name = "BUILDING_PART_PAGAN_GROVE_NAME", 
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_PAGAN_GROVE1",
	},
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createCircle( 10.0, {0.0, 0.0}, 64 ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = false } 
			}, 
            { 
                Polygon = polygon.createCircle( 2.5, {0.0, 0.0}, 64 ),
                Type = { DEFAULT = false, NAVIGABLE = true, GRASS_CLEAR = true } 
			}, 
		}
	},
    Category = "CORE",
    Capacity = 40,
    AssetBuildingFunction = "BUILDING_FUNCTION_PUBLIC_LOUNGE_ROOM",
	Cost = {
        BuildRightTaxes = {	{ Resource = "WOOD", Quantity = 100 } },
        -- UpkeepCost = { { Resource = "GOLD", Quantity = 10 } },
        -- RessourcesNeeded = {
        --     { Resource = "TOOL", Quantity = 5 },
		-- }
	},
    EstateSplendor = {
        { Estate = "CLERGY", Quantity = 1.00 },
    },
	DesirabilityModifiers = { 
        {
            Desirability = "DESIRABILITY_RESIDENTIAL",
            Type = "ADD",
            Radius = 25.0,
            Value = 0.5
    	} 
    },
})