local mod = ...



-- Asset -------------------------------------------------------------------------------------
mod:registerAssetId("models/Pagan5.fbx/Prefab/Spring1Part", "PREFAB_PAGAN_SPRING1")
mod:registerAssetId("models/Pagan5.fbx/Prefab/Spring1Part/WaterGenerator", "PREFAB_PAGAN_SPRING1_WATER")



-- Components -------------------------------------------------------------------------------------
mod:registerPrefabComponent("models/Pagan5.fbx/Prefab/Spring1Part/WaterGenerator", { DataType = "COMP_BUILDING_PART"})
mod:registerPrefabComponent("models/Pagan5.fbx/Prefab/Spring1Part/WaterGenerator", { DataType = "COMP_RESOURCE_GENERATOR"})

-- Custom Component: Add Water Well function to the water, in addition to the religious function of the parent part
local COMP_PAGAN_WATER = {
	TypeName = "COMP_PAGAN_WATER",
	ParentType = "COMPONENT",
	Properties = {
    }
}

function COMP_PAGAN_WATER:init()

    self:getOwner():getComponent("COMP_RESOURCE_GENERATOR"):setResourceGeneratorData("BUILDING_FUNCTION_WELL")

end

mod:registerClass(COMP_PAGAN_WATER)
mod:registerPrefabComponent("PREFAB_PAGAN_SPRING1_WATER", { DataType = "COMP_PAGAN_WATER" } )



-- Platform -------------------------------------------------------------------------------------
mod:configurePrefabFlagList("models/Pagan5.fbx/Prefab/Spring1Part", { "PLATFORM" })



-- Material -------------------------------------------------------------------------------------
mod:registerAssetId("models/Pagan5.fbx/Materials/Material.Reed", "MATERIAL_PAGAN_REED")
mod:override({
    Id = "MATERIAL_PAGAN_REED",
    HasAlphaTest = true
})

mod:registerAssetId("models/Pagan5.fbx/Materials/Material.Sycamore", "MATERIAL_PAGAN_SYCAMORE")
mod:override({
    Id = "MATERIAL_PAGAN_SYCAMORE",
    HasAlphaTest = true
})



-- Building Asset Processor -------------------------------------------------------------------------------------
mod:registerAssetProcessor("models/Pagan5.fbx", { DataType = "BUILDING_ASSET_PROCESSOR" })



-- Building Part: Spring 1 -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_PAGAN_SPRING1",
	Name = "BUILDING_PART_PAGAN_SPRING_NAME", 
	Description = "BUILDING_PART_PAGAN_SPRING_DESC", 
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_PAGAN_SPRING1",
	},
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createCircle( 3.9, {0.0, 0.0}, 64 ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = false } 
			}, 
            { 
                Polygon = polygon.createCircle( 2.0, {0.0, 0.0}, 64 ),
                Type = { DEFAULT = false, NAVIGABLE = true, GRASS_CLEAR = true } 
			}, 
		}
	},
    Category = "CORE",
    Capacity = 15,
    AssetBuildingFunction = "BUILDING_FUNCTION_PUBLIC_LOUNGE_ROOM",
	Cost = {
        BuildRightTaxes = {	
            { Resource = "STONE", Quantity = 20 },
            { Resource = "WOOD", Quantity = 10 },
        },
        -- UpkeepCost = { { Resource = "GOLD", Quantity = 10 } },
        -- RessourcesNeeded = {
        --     { Resource = "TOOL", Quantity = 5 },
		-- }
	},
    EstateSplendor = {
        { Estate = "CLERGY", Quantity = 0.5 },
    },
	DesirabilityModifiers = { 
        {
            Desirability = "DESIRABILITY_RESIDENTIAL",
            Type = "ADD",
            Radius = 15.0,
            Value = 0.5
    	} 
    },
})