local mod = ...



-- Asset -------------------------------------------------------------------------------------
mod:registerAssetId("models/Pagan1.fbx/Prefab/Volcano1Part", "PREFAB_PAGAN_VOLCANO1")



-- Components -------------------------------------------------------------------------------------



-- Platform -------------------------------------------------------------------------------------
mod:configurePrefabFlagList("models/Pagan1.fbx/Prefab/Volcano1Part", { "PLATFORM" })



-- Building Asset Processor -------------------------------------------------------------------------------------
mod:registerAssetProcessor("models/Pagan1.fbx", { DataType = "BUILDING_ASSET_PROCESSOR" })



-- Grounding -------------------------------------------------------------------------------------
-- mod:registerPrefabComponent("models/Pagan1.fbx/Prefab/Volcano1Part/Attach_Major.001", {DataType = "COMP_GROUNDED"})



-- Textures and Materials -------------------------------------------------------------------------------------
mod:registerAssetId("models/textures/fire.png", "TEXTURE_VOLCANO_FIRE")
mod:register({
	DataType = "MATERIAL",
	Id = "MATERIAL_VOLCANO_FIRE",
	AlbedoTexture = "TEXTURE_VOLCANO_FIRE"
})

mod:registerAssetId("models/textures/smoke.png", "TEXTURE_VOLCANO_SMOKE")
mod:register({
	DataType = "MATERIAL",
	Id = "MATERIAL_VOLCANO_SMOKE",
	AlbedoTexture = "TEXTURE_VOLCANO_SMOKE"
})



-- Particle: Fire -------------------------------------------------------------------------------------
mod:register({
	DataType = "PARTICLE_SYSTEM",
	Id = "PARTICLE_SYSTEM_VOLCANO_FIRE1",
	Material = "MATERIAL_VOLCANO_FIRE",
	BillboardBehavior = "FACE_CAMERA",
	Duration = 10.0,
	LifeTime = 8.0,
	Looping = true,
	Delay = { 0, 0 },
	StartSpeed = { 0.1, 0.1 },
	StartSize = { 75.0, 75.0 },
	StartRotation = { 0, 0 },
	StartColor = { 1, 1, 1, 1 },
	GravityModifier = -0.015,
	RateOverTime = 5,
    RateOverTimeRandom = 5,
	AlignWithVelocity = true,
	Shape = {
		DataType = "PARTICLE_EMITTER_SHAPE_CONE",
		Angle = 0.0,
		-- Radius = 0.0001,
		Radius = 0,
	},
    BurstList = {
        {
            DataType = "PARTICLE_BURST_DATA",
            Time = 0,
            Count = 10,
            Cycles = 3,
            Interval = 5.0,
        },
    },
	LinearVelocity = {
		DataType = "PARTICLE_FLOAT3_VALUE_CONSTANT_RANDOM",
		ValueA = { 0.1, 0, 0.1 },
		ValueB = { -0.1, 0, -0.1 }
	},
	ColorOverLifeTime = {
		DataType = "GRADIENT",
		ColorList = {
			{ T = 0, Color = { 0.6, 0.6, 0, 1} },
			{ T = 0.1, Color = { 0.4, 0.4, 0, 1} },
			{ T = 0.5, Color = { 0.4, 0.4, 0.4, 1 } },
			{ T = 1, Color = { 0.1, 0.1, 0.1, 0.5 } }
		},
		AlphaList = {
			{ T = 0.1, Alpha = 10 },
			{ T = 0.2, Alpha = 90 },
			{ T = 0.3, Alpha = 0 },
			{ T = 0.4, Alpha = 0 },
			{ T = 0.5, Alpha = 90 },
			{ T = 0.6, Alpha = 0 },
			{ T = 0.7, Alpha = 40 },
			{ T = 0.8, Alpha = 20 },
			{ T = 0.9, Alpha = 10 },
			{ T = 1, Alpha = 0 }
		},
	},
	SizeOverLifetime = {
			{ T = 0, Value = 0.1 },
			{ T = 0.5, Value = 0.2 },
			{ T = 1, Value = 0.3 }
	},
	RotationOverLifetime = { -70, 70 }
})

mod:registerPrefabComponent("models/Pagan1.fbx/Prefab/Volcano1Part/Emitter.001", {
	DataType = "COMP_PARTICLE_EMITTER",
	ParticleSystem = "PARTICLE_SYSTEM_VOLCANO_FIRE1",
	IsPlaying = true,
	IsEmitting = true
})



-- Particle: Smoke -------------------------------------------------------------------------------------
mod:register({
	DataType = "PARTICLE_SYSTEM",
	Id = "PARTICLE_SYSTEM_VOLCANO_SMOKE1",
	Material = "MATERIAL_VOLCANO_SMOKE",
	BillboardBehavior = "FACE_CAMERA",
	Duration = 16,
	LifeTime = 15,
	Looping = true,
	Delay = { 0, 0 },
	StartSpeed = { 0.3, 0.3 },
	StartSize = { 70.0, 70.0 },
	StartRotation = { 0, 0 },
	StartColor = { 1, 1, 1, 1 },
	GravityModifier = -.05,
	RateOverTime = 2,
	Shape = {
		DataType = "PARTICLE_EMITTER_SHAPE_CONE",
		Angle = 0.1,
		Radius = 0.0001,
	},
	LinearVelocity = {
		DataType = "PARTICLE_FLOAT3_VALUE_CONSTANT_RANDOM",
		ValueA = { 0.15, 0, 0.15 },
		ValueB = { -0.15, 0, -0.15 }
	},
	ColorOverLifeTime = {
		DataType = "GRADIENT",
		ColorList = {
			{ T = 0, Color = { 0.6, 0.6, 0, 1} },
			{ T = 0.1, Color = { 0.4, 0.4, 0, 1} },
			{ T = 0.5, Color = { 0.4, 0.4, 0.4, 1 } },
			{ T = 1, Color = { 0.1, 0.1, 0.1, 0.5 } }
		},
		AlphaList = {
			{ T = 0.1, Alpha = 0 },
			{ T = 0.2, Alpha = 20 },
			{ T = 0.4, Alpha = 30 },
			{ T = 0.6, Alpha = 40 },
			{ T = 0.7, Alpha = 80 },
			{ T = 0.8, Alpha = 30 },
			{ T = 1, Alpha = 0 }
		},
	},
	SizeOverLifetime = {
			{ T = 0.1, Value = 0.2 },
			{ T = 0.5, Value = 0.3 },
			{ T = 1, Value = 0.5 }
	},
	RotationOverLifetime = { -25, 25 }
})

mod:registerPrefabComponent("models/Pagan1.fbx/Prefab/Volcano1Part/Emitter.002", {
	DataType = "COMP_PARTICLE_EMITTER",
	ParticleSystem = "PARTICLE_SYSTEM_VOLCANO_SMOKE1",
	IsPlaying = true,
	IsEmitting = true
})



-- Building Part: Volcano -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_PAGAN_VOLCANO1",
	Name = "BUILDING_PART_PAGAN_VOLCANO_NAME", 
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_PAGAN_VOLCANO1",
	},
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createCircle( 32.0, {0.0, 0.0}, 64 ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = false } 
			}, 
		}
	},
    Category = "CORE",
    Capacity = 100,
    AssetBuildingFunction = "BUILDING_FUNCTION_PUBLIC_LOUNGE_ROOM",
	Cost = {
        BuildRightTaxes = {	{ Resource = "STONE", Quantity = 400 } },
        -- UpkeepCost = { { Resource = "GOLD", Quantity = 10 } },
        -- RessourcesNeeded = {
        --     { Resource = "TOOL", Quantity = 5 },
		-- }
	},
    EstateSplendor = {
        { Estate = "CLERGY", Quantity = 5.00 },
    },
	DesirabilityModifiers = { 
        {
            Desirability = "DESIRABILITY_RESIDENTIAL",
            Type = "SUBSTRACT",
            Radius = 55.0,
            Value = 0.5
    	} 
    },
})